.586
.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include ole32.inc		; Potrzebne dla 
   include oleaut32.inc		; BitmapFromResource
   include masm32.inc		;
   
   includelib user32.lib
   includelib kernel32.lib
   includelib gdi32.lib
   includelib ole32.lib		; Potrzebne dla
   includelib oleaut32.lib	; BitmapFromResource
   includelib masm32.lib	;


WinMain proto :DWORD,:DWORD,:DWORD,:DWORD


.data
   ClassName db "MainWinClass",0
   AppName   db "Main Window",0

.data?
   hInstance HINSTANCE ?
   CommandLine LPSTR ?

.const
   szerokosc equ 640
   wysokosc  equ 270

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc uses ebx hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	
	invoke BitmapFromResource, hInst, 100		; Uniwersalne,
	invoke CreatePatternBrush,eax				; niezawodne,
	push eax									; ponadczasowe!
	mov   wc.hbrBackground,eax                  ; 
		
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,hInst,101
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc

    pop eax
    invoke DeleteObject,eax
	
	invoke GetSystemMetrics , SM_CXSCREEN ; Obliczanie
    sub eax, szerokosc					  ; wspolrzednych
    shr eax, 1							  ; (x,y) do  
    push eax							  ; wysrodkowania
	invoke GetSystemMetrics , SM_CYSCREEN ; okna ;-)
    sub eax, wysokosc					  ;
    shr eax, 1						      ; Wiecie co robi [shr eax, 1] ?
    pop ebx								  ; Dzieli eax przez 2 ;-)
	
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
	                    WS_OVERLAPPEDWINDOW,\
	                    ebx,eax,szerokosc,wysokosc,\
	                    NULL,NULL,hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp


end start
